diff --git a/fluid/Fl_Type.cxx b/fluid/Fl_Type.cxx
index bbeb779..528e048 100644
--- a/fluid/Fl_Type.cxx
+++ b/fluid/Fl_Type.cxx
@@ -162,6 +162,7 @@ Fl_Pixmap *pixmap[] = { 0, &window_pixmap, &button_pixmap, &checkbutton_pixmap,
  &dial_pixmap, &roller_pixmap, &valueinput_pixmap, &valueoutput_pixmap, &comment_pixmap,             /* 42..46 */
  &spinner_pixmap, &widgetclass_pixmap, &data_pixmap, &tree_pixmap, &table_pixmap };                  /* 47..51 */
 
+extern int batch_mode;
 extern int show_comments;
 
 ////////////////////////////////////////////////////////////////
@@ -606,7 +607,8 @@ void Fl_Type::add(Fl_Type *p) {
   open_ = 1;
   fixvisible(this);
   set_modflag(1);
-  widget_browser->redraw();
+  if (!batch_mode)
+    widget_browser->redraw();
 }
 
 // add to a parent before another widget:
@@ -694,14 +696,14 @@ int storestring(const char *n, const char * & p, int nostrip) {
 void Fl_Type::name(const char *n) {
   int nostrip = is_comment();
   if (storestring(n,name_,nostrip)) {
-    if (visible) widget_browser->redraw();
+    if (visible && !batch_mode) widget_browser->redraw();
   }
 }
 
 void Fl_Type::label(const char *n) {
   if (storestring(n,label_,1)) {
     setlabel(label_);
-    if (visible && !name_) widget_browser->redraw();
+    if (visible && !name_ && !batch_mode) widget_browser->redraw();
   }
 }
 
diff --git a/fluid/Fl_Widget_Type.cxx b/fluid/Fl_Widget_Type.cxx
index 2e1ed41..832c21a 100644
--- a/fluid/Fl_Widget_Type.cxx
+++ b/fluid/Fl_Widget_Type.cxx
@@ -37,6 +37,7 @@
 // instance, sets the widget pointers, and makes all the display
 // update correctly...
 
+extern int batch_mode;
 extern int reading_file;
 int force_parent;
 extern int gridx;
@@ -262,7 +263,7 @@ void Fl_Widget_Type::redraw() {
     t->add_child(0,0);
   } else {
     while (t->parent && t->parent->is_widget()) t = t->parent;
-    ((Fl_Widget_Type*)t)->o->redraw();
+    if (!batch_mode) ((Fl_Widget_Type*)t)->o->redraw();
   }
 }
 
diff --git a/fluid/Fl_Window_Type.cxx b/fluid/Fl_Window_Type.cxx
index e6b8b64..c32f8e3 100644
--- a/fluid/Fl_Window_Type.cxx
+++ b/fluid/Fl_Window_Type.cxx
@@ -47,6 +47,7 @@ extern const char* i18n_function;
 extern const char* i18n_file;
 extern const char* i18n_set;
 
+extern int batch_mode;
 extern Fl_Preferences	fluid_prefs;
 
 inline int fl_min(int a, int b) { return (a < b ? a : b); } 
@@ -386,7 +387,7 @@ void Fl_Window_Type::add_child(Fl_Type* cc, Fl_Type* before) {
   Fl_Widget_Type* c = (Fl_Widget_Type*)cc;
   Fl_Widget* b = before ? ((Fl_Widget_Type*)before)->o : 0;
   ((Fl_Window*)o)->insert(*(c->o), b);
-  o->redraw();
+  if (!batch_mode) o->redraw();
 }
 
 void Fl_Window_Type::remove_child(Fl_Type* cc) {
